import java.awt.*;
import java.awt.Toolkit;
import java.awt.Image;
import java.awt.event.*;
import java.util.Random;
import PuzzleGame.*;

public class AppletTest
{	

	public static void main(String args[])
	{	
		TetrisPuzzlePiece pieces[] = new TetrisPuzzlePiece[7];
		pieces[0] = new TetrisPuzzlePiece(3,"100100110");
		pieces[1] = new TetrisPuzzlePiece(3,"010010110");
		pieces[2] = new TetrisPuzzlePiece(3,"010110100");
		pieces[3] = new TetrisPuzzlePiece(3,"100110010");
		pieces[4] = new TetrisPuzzlePiece(2,"1111");
		pieces[5] = new TetrisPuzzlePiece(3,"100110100");
		pieces[6] = new TetrisPuzzlePiece(4,"1000100010001000");
		
		Image images[] = new Image[7];
		images[0] = Toolkit.getDefaultToolkit().getImage("PuzzleGame/Images/yellow.gif");
		images[1] = Toolkit.getDefaultToolkit().getImage("PuzzleGame/Images/blue.gif");
		images[2] = Toolkit.getDefaultToolkit().getImage("PuzzleGame/Images/green.gif");
		images[3] = Toolkit.getDefaultToolkit().getImage("PuzzleGame/Images/purple.gif");
		images[4] = Toolkit.getDefaultToolkit().getImage("PuzzleGame/Images/grey.gif");
		images[5] = Toolkit.getDefaultToolkit().getImage("PuzzleGame/Images/red.gif");
		images[6] = Toolkit.getDefaultToolkit().getImage("PuzzleGame/Images/turquoise.gif");
		
		Image border[] = new Image[8];
		border[0] = Toolkit.getDefaultToolkit().getImage("PuzzleGame/Images/Border/topborder.gif");
		border[1] = Toolkit.getDefaultToolkit().getImage("PuzzleGame/Images/Border/bottomborder.gif");
		border[2] = Toolkit.getDefaultToolkit().getImage("PuzzleGame/Images/Border/leftborder.gif");		
		border[3] = Toolkit.getDefaultToolkit().getImage("PuzzleGame/Images/Border/rightborder.gif");
		border[4] = Toolkit.getDefaultToolkit().getImage("PuzzleGame/Images/Border/tlcorner.gif");
		border[5] = Toolkit.getDefaultToolkit().getImage("PuzzleGame/Images/Border/trcorner.gif");
		border[6] = Toolkit.getDefaultToolkit().getImage("PuzzleGame/Images/Border/blcorner.gif");
		border[7] = Toolkit.getDefaultToolkit().getImage("PuzzleGame/Images/Border/brcorner.gif");

		Frame frame = new Frame("Test");
		panel = new BildPanel();
		
		panel.area = new FramedArea(21,11);
		panel.area.setBorder(border);
		panel.score = new FramedArea(3, 8);
		panel.score.setBorder(border);
		panel.level = new FramedArea(3, 8);
		panel.level.setBorder(border);
		panel.next = new FramedArea(5, 5);
		panel.next.setBorder(border);
		
		MediaTracker tracker = new MediaTracker(panel);
		
		for (int i = 0; i < 7; i++)
		{
			tracker.addImage(images[i], 0);
			tracker.addImage(border[i], 0);
		}
		tracker.addImage(border[7], 0);
		try{tracker.waitForID(0);} catch (Exception exc) {}
		
		board = new TetrisGameBoard(20, 10, 20); // Hjd, bredd, gridsize
		board.setPieces(pieces, images);
		
		panel.setBoard(board);
		change_piece();
		panel.setLayout(new FlowLayout());
				
		frame.add(panel);
		frame.setName("Testapplikation");
		frame.setSize(640,480);
		frame.setResizable(false);
		frame.addWindowListener(
		new WindowAdapter()
		{
			public void windowClosing(WindowEvent wev)
			{
				System.exit(0);
			}
			
			public void windowActivated(WindowEvent wev)
			{
				panel.requestFocus();
			}
		});
		frame.show();
		frame.repaint();
	}
	
	public static void change_piece()
	{
		panel.setPiece();
	}
	
	private static TetrisGameBoard board;
	private static BildPanel panel;
}
