import java.awt.*;
import java.util.Timer;
import java.util.TimerTask;
import java.awt.event.*;
import PuzzleGame.*;
import java.applet.Applet;

public class BildPanel extends Panel
{

	public BildPanel()
	{
		super.setSize(640,480);
		super.setBackground(Color.black);
		super.setForeground(Color.white);
		this.addKeyListener( new KeyAdapter(){
					public void keyPressed(KeyEvent keye)
					{
						switch (keye.getKeyCode())
						{
							case KeyEvent.VK_LEFT:
								left();
								break;
							case KeyEvent.VK_RIGHT:
								right();
								break;
							case KeyEvent.VK_UP:
								rotate();
								break;
							case KeyEvent.VK_DOWN:
								drop();
								break;
						}
					}});
					gameover = false;
	}
	
	public void setPiece()
	{
		if (nextbiten != null)
			this.biten = nextbiten;
		else
		{
			this.biten = board.getRandomPiece();
			nextbiten = board.getRandomPiece();
			while (biten.getImage() == nextbiten.getImage())
				nextbiten = board.getRandomPiece();
		}
		nextbiten = board.getRandomPiece();
		biten.setLocation(new Point(0, board.gameBoardMatrix[0].length/2 - 1));
		this.repaint();
	}
		
	public void rotate()
	{
		TetrisPuzzlePiece temppiece = biten.getCopy();
		temppiece.rotateRight();
		
		while (board.checkForCollision(temppiece) > 0)
		{
			temppiece.move(0,-1);
		}
		
		if (board.checkForCollision(temppiece) == 0)
		{
			biten.clearPiece(20,20,this.getGraphics());
			biten.setLocation(temppiece.getLocation());
			biten.rotateRight();
			repaint();
		}
	}
	
	public void right()
	{
		TetrisPuzzlePiece temp = biten.getCopy();
		temp.move(0, 1);
		if (board.checkForCollision(temp) == 0)
		{
			biten.clearPiece(20,20,this.getGraphics());
			biten.move(0,1);
			biten.drawPiece(20,20,this.getGraphics());
		}
	}
	
	public void left()
	{
		TetrisPuzzlePiece temp = biten.getCopy();
		temp.move(0, -1);
		if (board.checkForCollision(temp) == 0)
		{
			biten.clearPiece(20,20,this.getGraphics());
			biten.move(0, -1);
			biten.drawPiece(20,20,this.getGraphics());
		}
	}
	
	public void drop()
	{
		TetrisPuzzlePiece temppiece = biten.getCopy();
		while (board.checkForCollision(temppiece) == 0)
		{
			temppiece.move(1,0);
		}

		biten.clearPiece(20,20,this.getGraphics());
		this.getGraphics().clearRect(270,180,80,80);
		if (temppiece.getLocation().x > 0)
		{
			temppiece.move(-1,0);
			gameover = true;
		}
		
		biten.setLocation(temppiece.getLocation());
		board.updateBoardWith(biten);
		board.applyGravity();
		board.drawBoard(20,20,this.getGraphics());		
		setPiece();
	}
	
	public void setBoard(TetrisGameBoard board)
	{
		this.board = board;
	}
		
	public void paint(Graphics gr)
	{
		board.drawBoard(20,20,gr);
		area.drawBorder(0, 0, gr);
		score.drawBorder(250, 0, gr);
		level.drawBorder(250, 80, gr);
		next.drawBorder(250, 160, gr);
		biten.drawPiece(20,20,gr);
		
		nextbiten.drawPiece(310-10*(nextbiten.getRightmostPosition()+1), //To center
		220-10*(nextbiten.getBottommostPosition()+1),gr);                //piece in frame
	}
	
	public void update(Graphics gr)
	{
		this.paint(gr);
	}
		
	private TetrisPuzzlePiece biten, nextbiten;
	private TetrisGameBoard board;
	private Timer timer;
	private boolean gameover;
	public FramedArea area;
	public FramedArea score;
	public FramedArea level;
	public FramedArea next;
}