import java.awt.Graphics;
import java.awt.Image;

public class FramedArea
{

/**
	Creates a basic FramedArea with a minimum size
*/
	public FramedArea()
	{
		this.row = 3;
		this.col = 2;
	}

/**
	Creates a FramedArea with a specific size
*/
	public FramedArea(int row, int col)
	{
		if ((row >= 3) && (col >= 2))
		{
			this.row = row;
			this.col = col;
		}
		else
		{
			this.row = 3;
			this.col = 2;
		}
	}
	
/**
 * Sets the images for the border of the frame
 * @param imagearray[]
 		An array containing the 8 images for a complete border.
		imagearray[0] - top border
		imagearray[1] - bottom border
		imagearray[2] - left border
		imagearray[3] - right border
		imagearray[4] - top left corner
		imagearray[5] - top right corner
		imagearray[6] - bottom left corner
		imagearray[7] - bottom right corner
 */		 
	public void setBorder(Image imagearray[])
	{
		if (imagearray.length == 8)
		{
			borders = new Image[8];
			
			for (int i = 0; i < 8; i++)
				borders[i] = imagearray[i];
		}
	}

/**
	Draws the borders on a Graphics page, with offset (x,y)
*/	
	public void drawBorder(int x, int y, Graphics page)
	{
		for (int i = 1; i < col; i++)
		{
			page.drawImage(borders[0], x + i*borders[0].getWidth(null), y, null);
			page.drawImage(borders[1], x + i*borders[1].getWidth(null), y + row * borders[2].getHeight(null), null);
		}
		
		for (int i = 1; i < row; i++)
		{
			page.drawImage(borders[2], x, y + i*borders[2].getHeight(null), null);
			page.drawImage(borders[3], x + col * borders[0].getWidth(null), y + i*borders[3].getHeight(null), null);
		}
		
		page.drawImage(borders[4],x ,y , null);
		page.drawImage(borders[5],x + col * borders[0].getWidth(null),y , null);
		page.drawImage(borders[6],x ,y + row * borders[2].getHeight(null), null);
		page.drawImage(borders[7],x + col * borders[0].getWidth(null),
														 y + row * borders[2].getHeight(null), null);
	}
	
	protected int row;
	protected int col;
	protected Image borders[];
}